import { Snippet } from './snippet';
export declare class Language {
    readonly name: string;
    private obj;
    /**
     * Creates a new Language instance.
     * @param name name of the language.
     * @param shortName short name of the language, used for syntax highlighting
     * @param files a list of files to use.
     */
    constructor(name: string, obj: any);
    /**
     * Searches for a Snippet.
     * @param name the name of the snippet to search for
     * @returns the snippet or undefined if no snippet was found.
     */
    getSnippet(name: string): Snippet;
    /**
     * Returns a list of snippet names.
     * @returns list of names
     */
    getSnippets(): string[];
}
